#!/usr/bin/env perl
use WWW::Mechanize;   # libwww-mechanize-perl 
use LWP::UserAgent;   # libwww-perl
use File::Basename;   # perl-modules

# Register https://www.clusterresources.com/myAccount/register.php

# https://www.clusterresources.com/myAccount/login.php
# https://www.clusterresources.com/product/maui
# https://www.clusterresources.com/download/maui/maui-3.2.6p21.tar.gz

my $Maui_login_url='https://www.clusterresources.com/myAccount/login.php';
my $Maui_top_url="https://www.clusterresources.com/products/maui-cluster-scheduler.php";
my $Maui_download_url='http://www.clusterresources.com/product/maui';
my $Maui_beta_download_url='http://www.clusterresources.com/product/maui/snapshots.php';
my $Maui_beta_download_no_script_url='http://www.clusterresources.com/download/maui/snapshots';
my $config_file='/etc/maui-helper/maui-site.conf';
my $release_file='/etc/maui-helper/release';
my $release = "";

sub get_release()
{
    my $fd;
    open $fd,'<', $release_file or return("");
    my $rel = <$fd>;
    $rel =~ s/[^0-9A-z\-\.]//g;
    close($fd);
    return $rel;
}
$release = get_release();

sub config_maui()
{
    my %config_hash = ( username=>'', password=>'', accept=>'no', usebeta=>'true' );
    
    open my $fd,'<',$config_file or die ($config_file);
    while(<$fd>){
	chop($_);
	$_ =~ s/\#.*$//g;
	$_ =~ s/[\t\s]//g;
	my @parms = split (/=/,$_);
	if ( $#parms == 1 ){
	    $config_hash{$parms[0]}=$parms[1];
	}
    }
    close($fd);
    return %config_hash;
}

# read configurartion file
my %def=config_maui();

# Licence Accept
exit(0) if ( $def{'accept'} =~ /^no$/i );

my $mech = WWW::Mechanize->new(agent=>'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.10) Gecko/2009042316 Firefox/3.0.10 (.NET CLR 3.5.30729)',
			       cookie_jar => {});

# get login form.
$mech->get( $Maui_login_url );
die($mech->res()->status_line() . ":" . "Login from.")
    unless ( $mech->res()->status_line() =~ /^200 OK/ );


# submit username password
$mech->submit_form(form_number => 2,
		   fields      => { username => $def{'username'},
				    password => $def{'password'},
				},
		   button      => 'submit'
		   );
die($mech->res()->status_line() . ":" . "Auth")
    unless ( $mech->res()->status_line() =~ /^200 OK/ );
die("There was an error with your username or password. see $config_file")
    unless ( $mech->content()
	 =~ /Welcome to Cluster Resources./ );

# Click - Download -> Maui
$mech->get( $Maui_top_url );
die($mech->res()->status_line() . ":" . "follow link.")
    unless ( $mech->res()->status_line() =~ /^200 OK/ );

# Click - Maui Cluster Scheduler – Download Now 
$mech->get( $Maui_download_url );
die($mech->res()->status_line() . ":" . "follow link.")
    unless ( $mech->res()->status_line() =~ /^200 OK/ );

# table Here
if (( $def{version} =~ /snap/i )||( $def{usebeta} =~ /true/i )){
    $mech->follow_link( url => $Maui_beta_download_url );
    die($mech->res()->status_line() . ":" . "follow link.")
	unless ( $mech->res()->status_line() =~ /^200 OK/ );
}

my @links;
push(@links,$mech->find_all_links('url_regex' => qr/maui\-[\-0-9A-z\.]+\.tar\.gz$/));

my $n = 0;
my $i = 0;
my $savefilename = 'Maui.tar.gz';
my $version = '';
foreach my $h (@links){
    $i++;
    if (( $i == 1 && $def{version} =~ /new/i )||
	( $h->url() =~ /$def{version}/ )){
	$n = $i;
	$savefilename = basename($h->url());
        $version = $savefilename;
	$version =~  s/(maui\-)([\-0-9A-z\.]+)\.tar\.gz/$2/g;
    }
}

if ( $#links > 0 ){
    if ( $release eq $version ) {
        print $version,"\n";
        exit(0);
    }
    if ( $version =~ /snap/i ){ # beta
	$mech->follow_link('n' => $n,
			   'url_regex' => qr/maui\-[\-0-9A-z\.]+\.tar\.gz$/,
	    ) or die();
	if ( $mech->res()->status_line() =~ /^404 Not Found/ ) {
	    $mech->back();
	    $mech->get(
		$Maui_beta_download_no_script_url . "/" . $savefilename
		);
	}
    }else{                      # release
	$mech->follow_link('n' => $n,
			   'url_regex' => qr/maui\-[\-0-9A-z\.]+\.tar\.gz$/,
	    ) or die();
    }
    if ( $mech->res()->status_line() =~ /^200 OK/ ) {
        open my $fd,'>',$savefilename or die($savefilename);
        print $fd $mech->content();
        close $fd;
        print $version,"\n";
    } else {
        die($mech->res()->status_line() . ":" . $savefilename);
    }

}
exit(0);
